from samplebase import SampleBase
import time
import curses
from curses import KEY_RIGHT, KEY_LEFT, KEY_UP, KEY_DOWN
from random import randint
from rgbmatrix import graphics

version = "v1.0"

class DIYSnake(SampleBase):
	def __init__(self, *args, **kwargs):
		super(DIYSnake, self).__init__(*args, **kwargs)

	def run(self):
#		Curses setup
		curses.initscr()
		win = curses.newwin(0 ,0 , 0, 0)
		win.keypad(1)
		curses.noecho()
		curses.curs_set(0)
		win.nodelay(1)

#		Loading fonts
		font = graphics.Font()
		font.LoadFont("../../../fonts/6x10.bdf")
		font1 = graphics.Font()
		font1.LoadFont("../../../fonts/Scott15.bdf")
		font2 = graphics.Font()
		font2.LoadFont("../../../fonts/Scott20.bdf")

#		Setting up the "screensaver"
		lightshowX = 15
		lightshowY = 30
		lightshowMX = 1
		lightshowMY = -1
		lightshowR = 0
		lightshowG = 0
		lightshowB = 0
		lightshowDelay = 0.005
		lightshowI = 0
		lightshowMvmntSpd = 7
		lightshowTimer = 0
		
		textColor = graphics.Color(randint(20, 255), randint(20, 255), randint(20, 255))
		textColorJIT = graphics.Color(255, 255, 255)
		textColorGO = graphics.Color(255, 64, 64)
		textColorLightshow = graphics.Color(lightshowR, lightshowG, lightshowB)

#		Creating a led-matrix canvas
		offset_canvas = self.matrix.CreateFrameCanvas()
		
		reset = 1
		lightshow = 0

		try:
			while True:

				if reset == 1:
					reset = 0
					stepSize = 3
					gameAreaFrame = [1 , 62, 11, 63]
					gameAreaMinMax = [gameAreaFrame[0] + round(stepSize / 2), gameAreaFrame[1] - round(stepSize / 2), gameAreaFrame[2] + round(stepSize / 2), gameAreaFrame[3] - round(stepSize / 2)]
					snakeStart = [gameAreaMinMax[0] + stepSize * 10, gameAreaMinMax[2]]
					snake = [snakeStart, [snakeStart[0] - stepSize, snakeStart[1]], [snakeStart[0] - stepSize * 2, snakeStart[1]],  [snakeStart[0] - stepSize * 3, snakeStart[1]], [snakeStart[0] - stepSize * 4, snakeStart[1]], [snakeStart[0] - stepSize * 5, snakeStart[1]], [snakeStart[0] - stepSize * 6, snakeStart[1]], [snakeStart[0] - stepSize * 7, snakeStart[1]]]
					food = [33, 28]
					key = KEY_RIGHT
					score = 0
					foodCounter = 0
					br = 0
			

					offset_canvas.Clear()
					graphics.DrawText(offset_canvas, font, 3, 9, textColor, "Score:" + str(score))
					graphics.DrawText(offset_canvas, font1, 10, 52, textColorJIT, "joy-it")
			
					for x in range(gameAreaFrame[0], gameAreaFrame[1]):
						offset_canvas.SetPixel(x, gameAreaFrame[2], 0, 0, 255)
				
					for x in range(gameAreaFrame[0], gameAreaFrame[1]):
						offset_canvas.SetPixel(x, gameAreaFrame[3], 0, 0, 255)
				
					for y in range(gameAreaFrame[2], gameAreaFrame[3]):
						offset_canvas.SetPixel(gameAreaFrame[0], y, 0, 0, 255)

					for y in range(gameAreaFrame[2], gameAreaFrame[3] + 1):
						offset_canvas.SetPixel(gameAreaFrame[1], y, 0, 0, 255)

					for xy in snake[:1]:
						offset_canvas.SetPixel(xy[0] - 1, xy[1] - 1, 255, 127, 36)
						offset_canvas.SetPixel(xy[0] - 1, xy[1], 255, 127, 36)
						offset_canvas.SetPixel(xy[0] - 1, xy[1] + 1, 255, 127, 36)
						offset_canvas.SetPixel(xy[0], xy[1] - 1, 255, 127, 36)
						offset_canvas.SetPixel(xy[0], xy[1], 255, 127, 36)
						offset_canvas.SetPixel(xy[0], xy[1] + 1, 255, 127, 36)
						offset_canvas.SetPixel(xy[0] + 1, xy[1] - 1, 255, 127, 36)
						offset_canvas.SetPixel(xy[0] + 1, xy[1], 255, 127, 36)
						offset_canvas.SetPixel(xy[0] + 1, xy[1] + 1, 255, 127, 36)

					for xy in snake[1:]:
						offset_canvas.SetPixel(xy[0] - 1, xy[1] - 1, 0, 255, 0)
						offset_canvas.SetPixel(xy[0] - 1, xy[1], 0, 255, 0)
						offset_canvas.SetPixel(xy[0] - 1, xy[1] + 1, 0, 255, 0)
						offset_canvas.SetPixel(xy[0], xy[1] - 1, 0, 255, 0)
						offset_canvas.SetPixel(xy[0], xy[1], 0, 255, 0)
						offset_canvas.SetPixel(xy[0], xy[1] + 1, 0, 255, 0)
						offset_canvas.SetPixel(xy[0] + 1, xy[1] - 1, 0, 255, 0)
						offset_canvas.SetPixel(xy[0] + 1, xy[1], 0, 255, 0)
						offset_canvas.SetPixel(xy[0] + 1, xy[1] + 1, 0, 255, 0)
					offset_canvas.SetPixel(food[0], food[1], 255, 0, 0)
					offset_canvas.SetPixel(food[0] + 1, food[1], 255, 0, 0)
					offset_canvas.SetPixel(food[0] - 1,food[1], 255, 0, 0)
					offset_canvas.SetPixel(food[0], food[1] + 1, 255, 0, 0)
					offset_canvas.SetPixel(food[0], food[1] - 1, 255, 0, 0)
					offset_canvas = self.matrix.SwapOnVSync(offset_canvas)
					time.sleep(3)

				
				if br == 0:
					offset_canvas.Clear()
					textColor = graphics.Color(randint(20, 255), randint(20, 255), randint(20, 255))


					graphics.DrawText(offset_canvas, font, 3, 9, textColor, "Score:" + str(score))
				
					for x in range(gameAreaFrame[0], gameAreaFrame[1]):
						offset_canvas.SetPixel(x, gameAreaFrame[2], 0, 0, 255)

					for x in range(gameAreaFrame[0], gameAreaFrame[1]):
						offset_canvas.SetPixel(x, gameAreaFrame[3], 0, 0, 255)

					for y in range(gameAreaFrame[2], gameAreaFrame[3]):
						offset_canvas.SetPixel(gameAreaFrame[0], y, 0, 0, 255)

					for y in range(gameAreaFrame[2], gameAreaFrame[3] + 1):
						offset_canvas.SetPixel(gameAreaFrame[1], y, 0, 0, 255)

					for xy in snake[:1]:
						offset_canvas.SetPixel(xy[0] - 1, xy[1] - 1, 255, 127, 36)
						offset_canvas.SetPixel(xy[0] - 1, xy[1], 255, 127, 36)
						offset_canvas.SetPixel(xy[0] - 1, xy[1] + 1, 255, 127, 36)
						offset_canvas.SetPixel(xy[0], xy[1] - 1, 255, 127, 36)
						offset_canvas.SetPixel(xy[0], xy[1], 255, 127, 36)
						offset_canvas.SetPixel(xy[0], xy[1] + 1, 255, 127, 36)
						offset_canvas.SetPixel(xy[0] + 1, xy[1] - 1, 255, 127, 36)
						offset_canvas.SetPixel(xy[0] + 1, xy[1], 255, 127, 36)
						offset_canvas.SetPixel(xy[0] + 1, xy[1] + 1, 255, 127, 36)

					for xy in snake[1:]:
						offset_canvas.SetPixel(xy[0] - 1, xy[1] - 1, 0, 255, 0)
						offset_canvas.SetPixel(xy[0] - 1, xy[1], 0, 255, 0)
						offset_canvas.SetPixel(xy[0] - 1, xy[1] + 1, 0, 255, 0)
						offset_canvas.SetPixel(xy[0], xy[1] - 1, 0, 255, 0)
						offset_canvas.SetPixel(xy[0], xy[1], 0, 255, 0)
						offset_canvas.SetPixel(xy[0], xy[1] + 1, 0, 255, 0)
						offset_canvas.SetPixel(xy[0] + 1, xy[1] - 1, 0, 255, 0)
						offset_canvas.SetPixel(xy[0] + 1, xy[1], 0, 255, 0)
						offset_canvas.SetPixel(xy[0] + 1, xy[1] + 1, 0, 255, 0)

					offset_canvas.SetPixel(food[0], food[1], 255, 0, 0)
					offset_canvas.SetPixel(food[0] + 1, food[1], 255, 0, 0)
					offset_canvas.SetPixel(food[0] - 1,food[1], 255, 0, 0)
					offset_canvas.SetPixel(food[0], food[1] + 1, 255, 0, 0)
					offset_canvas.SetPixel(food[0], food[1] - 1, 255, 0, 0)
					offset_canvas = self.matrix.SwapOnVSync(offset_canvas)
					time.sleep(0.07 * ((104 - len(snake) / 2) / 50))
					offset_canvas.Clear()

					snake.insert(0, [snake[0][0] + (key == KEY_RIGHT and stepSize) + (key == KEY_LEFT and -stepSize), snake[0][1] + (key == KEY_UP and -stepSize) + (key == KEY_DOWN and stepSize)])
				
					prevKey = key
					event = win.getch()
					key = key if event == -1 else event

					if key not in [KEY_LEFT, KEY_RIGHT, KEY_UP, KEY_DOWN]:
						key = prevKey
					
					if prevKey == KEY_RIGHT and key == KEY_LEFT: key = prevKey
					if prevKey == KEY_LEFT and key == KEY_RIGHT: key = prevKey
					if prevKey == KEY_UP and key == KEY_DOWN: key = prevKey
					if prevKey == KEY_DOWN and key == KEY_UP: key = prevKey

#					Softboarders
#					if snake[0][0] == gameAreaMinMax[0] - stepSize: snake[0][0] = gameAreaMinMax[1]
#					if snake[0][1] == gameAreaMinMax[2] - stepSize: snake[0][1] = gameAreaMinMax[3]
#					if snake[0][0] == gameAreaMinMax[1] + stepSize: snake[0][0] = gameAreaMinMax[0]
#					if snake[0][1] == gameAreaMinMax[3] + stepSize: snake[0][1] = gameAreaMinMax[2]

#					Hardboarders
					if snake[0] in snake[1:] or snake[0][0] == gameAreaMinMax[0] - stepSize or snake[0][1] == gameAreaMinMax[2] - stepSize or snake[0][0] == gameAreaMinMax[1] + stepSize or snake[0][1] == gameAreaMinMax[3] + stepSize: br = 1


					if snake[0] in snake[1:]: br = 1
				
					if snake[0] == food or foodCounter > 0:
						if snake[0] == food:
							food = []
							score += 10
							foodCounter = 1
						if foodCounter > 0:
							foodCounter -= 1
						while food == []:
							food = [randint(1,(gameAreaMinMax[1] - gameAreaMinMax[0]) / stepSize) * stepSize + gameAreaMinMax[0], randint(1,(gameAreaMinMax[3] - gameAreaMinMax[2]) / stepSize) * stepSize + gameAreaMinMax[2]]
							if food in snake: food = []
					else:
						snake.remove(snake[len(snake)-1])

				elif lightshow == 1:

					key = []
					prevKey = key
					event = win.getch()
					key = key if event == -1 else event
					
					lightshowI += 1
					
					if lightshowR < 255 and lightshowG == 0 and lightshowB == 0:
						lightshowR += 1
					elif lightshowR == 255 and lightshowG == 0 and lightshowB < 255:
						lightshowB += 1
					elif lightshowR <= 255 and lightshowR > 0 and lightshowG == 0 and lightshowB == 255:
						lightshowR -= 1
					elif lightshowR == 0 and lightshowG < 255 and lightshowB == 255:
						lightshowG += 1
					elif lightshowR == 0 and lightshowG == 255 and lightshowB <= 255 and lightshowB > 0:
						lightshowB -= 1
					elif lightshowR < 255 and lightshowG == 255 and lightshowB == 0:
						lightshowR += 1
					elif lightshowR == 255 and lightshowG <= 255 and lightshowG > 0 and lightshowB == 0:
						lightshowG -= 1
						
					if lightshowI == lightshowMvmntSpd:
						lightshowI = 0
						if lightshowX == 20:
							lightshowMX = -1
						if lightshowX == 0:
							lightshowMX = 1
						if lightshowY == 64:
							lightshowMY = -1
						if lightshowY == 23:
							lightshowMY = 1
						lightshowX += lightshowMX
						lightshowY += lightshowMY
					
					
					textColorLightshow = graphics.Color(lightshowR, lightshowG, lightshowB)

					offset_canvas.Clear()
					graphics.DrawText(offset_canvas, font1, lightshowX, lightshowY, textColorLightshow, "joy-it")
					graphics.DrawText(offset_canvas, font, 1, 9, textColorJIT, "Press 'ESC'")
					offset_canvas = self.matrix.SwapOnVSync(offset_canvas)
					time.sleep(lightshowDelay)

					
					if key == 27:
						br = 0
						reset = 1
						lightshow = 0
						lightshowTimer = 0

				else:
					key = []
					prevKey = key
					event = win.getch()
					key = key if event == -1 else event

					graphics.DrawText(offset_canvas, font1, 10, 52, textColorJIT, "joy-it")

					graphics.DrawText(offset_canvas, font, 5, 28, textColorGO, "GAME OVER")

					offset_canvas = self.matrix.SwapOnVSync(offset_canvas)
					time.sleep(0.4)

					lightshowTimer += 1

					if key == 27:
						br = 0
						reset = 1
					
					if key == 97 or lightshowTimer == 300:
						lightshowTimer = 0
						lightshow = 1
		except KeyboardInterrupt:
			curses.endwin()
		
		
# Main function
if __name__ == "__main__":
	diy_snake = DIYSnake()
	if (not diy_snake.process()):
		diy_snake.print_help()